unit uExcelExportImport;

  {$MODE Delphi}

interface

uses
  Grids, uExcelFile, stdctrls, SysUtils, Controls, Forms,
  {$IFDEF WINDOWS}
  Windows,
  {$ELSE}
  LCLType,
  {$ENDIF}
  ComCtrls,
  uModeloSintCEGH, uFuenteSintetizador, ufichasLPD, xMatDefs, uFechas, uCosa,
  uauxiliares;

resourcestring
  mesElNumeroDeColumnasEnElExcelNoCoincideConElNumeroDeBornesEnElSintetizador =
    'El nmero de columnas en el excel no coincide con el nmero de bornes en el sintetizador';
  RS_NoSeEncontroFinDeDatosHorarios= 'No se encontro la fila final de los datos horarios.' ;
  RS_NoSeEncontroFilaDeInicio = 'No se encontr la fila inicial.';

procedure exportarTablaAExcel_1(var xls: TExcelFile; tabla: TStringGrid;
  filaIni, filaFin, colIni, colFin: Integer;
  nFilasEncabezado, nColumnasEncabezado: Integer; SeriesEnColumnas: boolean;
  tiposSeries: string; // ' S,I,F,D  String, Integer, Float, Date
  bImportar: TButton; PBExportacion: TProgressBar);

procedure importarTablaDesdeExcel_1(var xls: TExcelFile; tabla: TStringGrid;
  filaIni, filaFin, colIni, colFin: Integer; bImportar: TButton;
  PBImportacion: TProgressBar; chequeoEncabezadosFila,
  chequeoEncabezadosColumna: boolean);

// Asume filaIni = 0, colIni = 0, filaFin = tabla.RowCount - 1 y
// colFin = tabla.ColCount - 1
procedure exportarTablaAExcel_2(var xls: TExcelFile; tabla: TStringGrid;
  bImportar: TButton; PBExportacion: TProgressBar);

// Asume filaIni = tabla.fixedRows, colIni = tabla.fixedCols,
// filaFin = tabla.RowCount - 1 y colFin = tabla.ColCount - 1
procedure importarTablaDesdeExcel_2(var xls: TExcelFile; tabla: TStringGrid;
  bImportar: TButton; PBImportacion: TProgressBar; chequeoEncabezadosFila,
  chequeoEncabezadosColumna: boolean);

procedure exportarTablaAExcel_3(tabla: TStringGrid;
  filaIni, filaFin, colIni, colFin: Integer);
procedure exportarTablaAExcel_4(tabla: TStringGrid; filaIni, filaFin: Integer;
  cols: array of Integer);

procedure exportarPromStdDevDatosModeloCEGHAExcel(var xls: TExcelFile;
  const datosModelo: TModeloSintetizadorCEGH);



(* Exportar "datos" horarios. *)
procedure importarDatosHorariosDesdeExcel(
  var xls: TExcelFile; var datos: TDAOfNReal;
  var fechaIni: TDateTime;
  bImportar: TButton;
  PBImportacion: TProgressBar;
  chequeoEncabezadosFila, chequeoEncabezadosColumna: boolean);

(* Importar "datos" horarios. *)
procedure exportarDatosHorariosAExcel(
  var xls: TExcelFile;
  const datos: TDAOfNreal;
  fechaIni: TDateTime;
  bImportar: TButton; PBExportacion: TProgressBar);


function estaEnModoEdicion: boolean;



implementation

function estaEnModoEdicion: boolean;
begin
  if (Application.MessageBox(
      'Antes de continuar asegurese de que no se encuentre editando una celda en la planilla de Excel.'#10
        + 'Si lo est haciendo salga del modo edicin y presione continuar.'#10 +
        'Desea continuar?', 'Confirmar', MB_YESNO + MB_ICONEXCLAMATION) = IDYES)
    then
    result := False
  else
    result := True;
end;

procedure exportarTablaAExcel_3(tabla: TStringGrid;
  filaIni, filaFin, colIni, colFin: Integer);
var
  i, j: Integer;
  xls: TExcelFile;
  cursorAnterior: TCursor;
begin
  cursorAnterior := Screen.Cursor;
  Screen.Cursor := crHourGlass;

  xls := TExcelFile.Create('x', False, False, True);
  try
    xls.go('x', 1, 1);
    for i := filaIni to filaFin do
    begin
      for j := colIni to colFin do
        xls.Write(tabla.Cells[j, i]);
      // WriteBuffereado(tabla.Cells[j, i]);
      // xls.WriteLnBuffer;
      xls.writeln;
    end;
  finally
    Screen.Cursor := cursorAnterior;
    xls.VisibleOn;
    xls.Free;
  end;
end;

procedure exportarTablaAExcel_4(tabla: TStringGrid; filaIni, filaFin: Integer;
  cols: array of Integer);
var
  i, j: Integer;
  xls: TExcelFile;
  cursorAnterior: TCursor;
begin
  cursorAnterior := Screen.Cursor;
  Screen.Cursor := crHourGlass;

  xls := TExcelFile.Create('x', False, False, True);
  try
    xls.go('x', 1, 1);
    for i := filaIni to filaFin do
    begin
      for j := 0 to High(cols) do
        xls.Write(tabla.Cells[cols[j], i]);
      xls.writeln;
    end;
  finally
    Screen.Cursor := cursorAnterior;
    xls.VisibleOn;
    xls.Free;
  end;
end;

procedure exportarPromStdDevDatosModeloCEGHAExcel(var xls: TExcelFile;
  const datosModelo: TModeloSintetizadorCEGH);
var
  i, j: Integer;
  cursorAnterior: TCursor;
  nPuntosPorPeriodo: Integer;
begin
  cursorAnterior := Screen.Cursor;
  Screen.Cursor := crHourGlass;
  { if PBExportacion <> NIL then
    begin
    PBExportacion.Min:= filaIni;
    PBExportacion.Max:= filaFin div 64 + 1;
    PBExportacion.Position:= filaIni;
    PBExportacion.Step:= 1;
    end; }

  if (xls = NIL) or not(xls.libroAbierto) then
    xls := TExcelFile.Create('x', False, True, False)
  else
   xls.VisibleOff;

  try
    xls.go('x', 1, 2);

    for i := 0 to datosModelo.nBornesSalida - 1 do
    begin
      xls.Write(datosModelo.NombresDeBornes_Publicados[i]);
      xls.Write('');
    end;
    xls.Writeln;

    xls.Write('Funcin Deformante');
    for i := 0 to datosModelo.nBornesSalida - 1 do
    begin
      xls.Write('Promedio');
      xls.Write('Desviacin Estandar');
    end;
    xls.WriteLn;

    nPuntosPorPeriodo := length(datosModelo.funcionesDeformantes[0]);

    for i := 1 to nPuntosPorPeriodo do
    begin
      xls.Write(i);
      for j := 0 to datosModelo.nBornesSalida - 1 do
      begin
        xls.write(datosModelo.funcionesDeformantes[j][i - 1].a.promedio);
        xls.write(datosModelo.funcionesDeformantes[j][i - 1].a.desviacionEstandar);
      end;
      xls.writeln;
    end;

    // formatedo del rea de datos
    xls.SelRango(3, 2, 2 + nPuntosPorPeriodo,
      1 + datosModelo.NombresDeBornes_Publicados.Count * 2);
    xls.CambiarFormato(xf_formatoStr(1));
    xls.ir(1, 1);

    xls.autoFitCells;
    // bImportar.Enabled:= true;
    xls.VisibleOn;
    Screen.Cursor := cursorAnterior;
  except
    Screen.Cursor := cursorAnterior;
    xls.Cerrar(false);
    xls.Free;
    xls := NIL;
  end;
end;



procedure exportarTablaAExcel_1(var xls: TExcelFile; tabla: TStringGrid;
  filaIni, filaFin, colIni, colFin: Integer;
  nFilasEncabezado, nColumnasEncabezado: Integer; SeriesEnColumnas: boolean;
  tiposSeries: string;
  // ' S,I,F,D  String, Integer, Float, Date
  bImportar: TButton; PBExportacion: TProgressBar);
var
  i, j: Integer;
  kfil, jcol: Integer;
  ctipo: char;
  ts: string;
  cursorAnterior: TCursor;
begin
  cursorAnterior := Screen.Cursor;
  Screen.Cursor := crHourGlass;
  if PBExportacion <> NIL then
  begin
    PBExportacion.Min := filaIni;
    PBExportacion.Max := filaFin div 64 + 1;
    PBExportacion.Position := filaIni;
    PBExportacion.Step := 1;
  end;

  if xls = NIL then
    xls := TExcelFile.Create('x', False, True, False)
  else
  begin
    if not xls.libroAbierto then
    begin
      xls.agregoLibro;
      xls.agregoHoja('x');
    end;
    xls.VisibleOff;
  end;

  try
    xls.go('x', 1, 1);
    for i := filaIni to filaFin do
    begin
      kfil := i - nFilasEncabezado;
      for j := colIni to colFin do
      begin
        jcol := j - nColumnasEncabezado;
        if (kfil < 0) or (jcol < 0) then
          xls.write(tabla.Cells[j, i])
        else
        begin
          ctipo := 's';
          if SeriesEnColumnas then
          begin
            if length(tiposSeries) > jcol then
              ctipo := tiposSeries[jcol + 1];
          end
          else
          begin
            if length(tiposSeries) > kfil then
              ctipo := tiposSeries[kfil + 1]
          end;

          ts := tabla.Cells[j, i];
          if ctipo <> 's' then
            if ts = '' then
              ts := '0';

          case ctipo of
            's':
              xls.write(tabla.Cells[j, i]);
            'i':
              xls.Write(StrToInt(ts));
            'f':
              xls.Write(StrToFloat(ts));
            'd':
              xls.Write(StrToDate(ts));
          end;
        end;
      end;
      xls.writeln;
      if (PBExportacion <> NIL) and (i mod 64 = 0) then
        PBExportacion.StepIt;
    end;
    bImportar.Enabled := True;
    xls.VisibleOn;
    Screen.Cursor := cursorAnterior;
  except
    Screen.Cursor := cursorAnterior;
    xls.Cerrar(False);
    xls.Free;
    xls := NIL;
  end;
end;

procedure importarTablaDesdeExcel_1(var xls: TExcelFile; tabla: TStringGrid;
  filaIni, filaFin, colIni, colFin: Integer; bImportar: TButton;
  PBImportacion: TProgressBar; chequeoEncabezadosFila,
  chequeoEncabezadosColumna: boolean);
var
  i, j: Integer;
  encabsIguales: boolean;
  valCeldaReal: Double;
  valCelda: String;
  cursorAnterior: TCursor;
begin
  if not estaEnModoEdicion then
  begin
    cursorAnterior := Screen.Cursor;
    Screen.Cursor := crHourGlass;

    bImportar.Enabled := False;
    if (xls <> NIL) then
    begin
      if xls.libroAbierto then
      begin
        try
          xls.VisibleOff;
          xls.ActivoHoja_numero(1);
          encabsIguales := True;

          if PBImportacion <> NIL then
          begin
            PBImportacion.Min := filaIni;
            if tabla.FixedCols >= 1 then
              PBImportacion.Max := tabla.RowCount div 64 + filaFin div 64 + 2
            else
              PBImportacion.Max := tabla.FixedRows div 64 + filaFin div 64 + 2;
            PBImportacion.Position := filaIni;
            PBImportacion.Step := 1;
          end;

          // Chequeo que los encabezados sean los mismos
          xls.ir(1, 1);

          if chequeoEncabezadosFila then
          begin
            for i := 0 to tabla.FixedRows - 1 do
            begin
              for j := 0 to tabla.ColCount - 1 do
              begin
                valCelda := xls.ReadV_Str;
                encabsIguales := tabla.Cells[j, i] = valCelda;
                if not encabsIguales then
                  break;
              end;
              xls.readln;
              if (PBImportacion <> NIL) and (i mod 64 = 0) then
                PBImportacion.StepIt;
            end;
          end
          else
            encabsIguales := True;

          if encabsIguales and chequeoEncabezadosColumna then
          begin
            for j := 0 to tabla.FixedCols - 1 do
              for i := tabla.FixedRows to tabla.RowCount - 1 do
              begin
                xls.ir(i + 1, j + 1);
                valCelda := xls.ReadV_Str;
                encabsIguales := tabla.Cells[j, i] = valCelda;
                if not encabsIguales then
                  break;
                if (PBImportacion <> NIL) and (i mod 64 = 0) then
                  PBImportacion.StepIt;
              end;
          end;

          // Termine de chequear los encabezados
          if encabsIguales then
          begin
            for i := filaIni to filaFin do
            begin
              xls.ir(i + 1, colIni + 1);
              for j := colIni to colFin do
                try
                  valCeldaReal := xls.ReadV_Float;
                  tabla.Cells[j, i] := FloatToStrF(valCeldaReal, ffGeneral, 12, 3);
                Except
                  tabla.Cells[j, i] := xls.ReadV_Str;
                end;
              if (PBImportacion <> NIL) and (i mod 64 = 0) then
                PBImportacion.StepIt;
            end;
          end
          else
            raise Exception.Create(
              'Los encabezados en el EXCEL difieren de los encabezados en la tabla.'
              );
        finally
          Screen.Cursor := cursorAnterior;
          xls.Cerrar(False);
        end;
      end;
      xls.Free;
      xls := NIL;
      Screen.Cursor := cursorAnterior;
    end;
  end;
end;

// Asumen filaIni = tabla.fixedRows, colIni = tabla.fixedCols,
// filaFin = tabla.RowCount - 1 y colFin = tabla.ColCount - 1
procedure exportarTablaAExcel_2(var xls: TExcelFile; tabla: TStringGrid;
  bImportar: TButton; PBExportacion: TProgressBar);
var
  seriesEnColumnas: boolean;
  defTipos: string;
  nFilas, nColumnas: integer;
  nSeries: integer;
  k: integer;

begin
  nFilas := tabla.RowCount - tabla.FixedRows;
  nColumnas := tabla.ColCount - tabla.FixedCols;

  if (nFilas > nColumnas) then
  begin
    SeriesEnColumnas := True;
    nSeries := nColumnas
  end
  else
  begin
    SeriesEnColumnas := False;
    nSeries := nFilas;
  end;

  SetLength(defTipos, nSeries);
  for k := 1 to nSeries do
    defTipos[k] := 'f';

  exportarTablaAExcel_1(xls, tabla, 0, tabla.RowCount - 1, 0, tabla.ColCount - 1,
    tabla.FixedRows, tabla.FixedCols, SeriesEnColumnas, defTipos, bImportar,
    PBExportacion);
end;

procedure importarTablaDesdeExcel_2(var xls: TExcelFile; tabla: TStringGrid;
  bImportar: TButton; PBImportacion: TProgressBar; chequeoEncabezadosFila,
  chequeoEncabezadosColumna: boolean);
begin
  importarTablaDesdeExcel_1(xls, tabla, tabla.FixedRows, tabla.RowCount - 1,
    tabla.FixedCols, tabla.ColCount - 1, bImportar, PBImportacion,
    chequeoEncabezadosFila, chequeoEncabezadosColumna);
end;



procedure exportarDatosHorariosAExcel(
  var xls: TExcelFile;
  const datos: TDAOfNreal;
  fechaIni: TDateTime;
  bImportar: TButton; PBExportacion: TProgressBar);
var
  NDias, iHora, iDia: integer;
  cursorAnterior: TCursor;
begin
  cursorAnterior := Screen.Cursor;
  Screen.Cursor := crHourGlass;
  NDias:= length( datos ) div 24;

  if PBExportacion <> NIL then
  begin
    PBExportacion.Min := 0;
    PBExportacion.Max := NDias div 30;
    PBExportacion.Position := 0;
    PBExportacion.Step := 1;
  end;

  if xls = NIL then
    xls := TExcelFile.Create('x', False, True, False)
  else
  begin
    if not xls.libroAbierto then
    begin
      xls.agregoLibro;
      xls.agregoHoja('x');
    end;
    xls.VisibleOff;
  end;

  try
    xls.go('x', 1, 1);

    xls.write( '' );
    for iHora:= 0 to 23 do
      xls.write( ihora );
    xls.writeln;

    try
      setSeparadoresGlobales;
      for iDia:= 1 to NDias do
      begin
        xls.write( DateTimeToStr( fechaIni+iDia-1 ) );
        for iHora:= 0 to 23 do
          xls.write( datos[ (iDia-1)*24 + iHora ] );
        xls.writeln;
        if (PBExportacion <> NIL) and (iDia mod 30 = 0) then
            PBExportacion.StepIt;
      end;
    finally
      setSeparadoresLocales;
    end;
    bImportar.Enabled := True;
    xls.VisibleOn;
    Screen.Cursor := cursorAnterior;
  except
    Screen.Cursor := cursorAnterior;
    xls.Cerrar(False);
    xls.Free;
    xls := NIL;
  end;
end;


procedure importarDatosHorariosDesdeExcel(
  var xls: TExcelFile; var datos: TDAOfNReal;
  var fechaIni: TDateTime;
  bImportar: TButton;
  PBImportacion: TProgressBar;
  chequeoEncabezadosFila, chequeoEncabezadosColumna: boolean);

var
  i, j: Integer;
  valr: Double;
  vali: integer;
  vals: string;
  cursorAnterior: TCursor;
  buscando: boolean;
  iHora, iDia: integer;
  irow, irow_PrimerDia, irow_UltimoDia: integer;
  icol: integer;
  NDias: integer;

begin
  if not estaEnModoEdicion then
  begin
    cursorAnterior := Screen.Cursor;
    Screen.Cursor := crHourGlass;
    setSeparadoresGlobales;

    bImportar.Enabled := False;
    if (xls <> NIL) then
    begin
      if xls.libroAbierto then
      begin
        try
          xls.VisibleOff;
          xls.ActivoHoja_numero(1);

          irow:= 1; icol:= 2;
          xls.ir(irow, icol);
          buscando:= true;

          while buscando and (irow < 1000) do
          begin
            vali := xls.ReadV_Int;
            if vali = 0 then
              buscando:= false
            else
            begin
              inc( irow );
              xls.ir(irow, icol);
            end;
          end;

          if buscando then
            raise Exception.Create( RS_NoSeEncontroFilaDeInicio );

          buscando:= false;
          for iHora:= 1 to 23 do
          begin
              vali:= xls.ReadV_int;
              if vali <> iHora then
                raise Exception.Create( RS_NoSeEncontroFilaDeInicio );
          end;
          irow_primerDia:= irow+1;
          xls.ir(irow_primerDia, 1 );
          valr:= xls.ReadV_Float;
          vals:= DateTimeToStr( valr );
          FechaIni:= StrToDateTime( vals );
          buscando:= true;
          irow_ultimoDia:= irow_primerDia;
          while buscando and (irow_UltimoDia < 65536) do
          begin
            vals:= xls.ReadV_Str;
            if vals = '' then
              buscando:= false
            else
            begin
              inc( irow_UltimoDia );
              xls.ir(irow_UltimoDia, 2 );
            end;
          end;

          if buscando then
            raise Exception.Create( RS_NoSeEncontroFinDeDatosHorarios );


          dec( irow_UltimoDia );
          NDias:= irow_UltimoDia - irow_PrimerDia +1 ;
          setlength( datos, NDias * 24 );


          if PBImportacion <> NIL then
          begin
             PBImportacion.Min := 0;
             PBImportacion.Max := NDias div 30;
             PBImportacion.Position := 0;
             PBImportacion.Step := 1;
          end;


          for iDia:= 0 to NDias-1 do
          begin
            xls.ir( irow_PrimerDia + iDia, 2 );
            for ihora:= 0 to 23 do
              datos[ iDia * 24 + ihora ]:= xls.ReadV_Float;
            if (PBImportacion <> NIL) and (iDia mod 30 = 0) then
              PBImportacion.StepIt;
          end;

        finally
          setSeparadoresLocales;
          Screen.Cursor := cursorAnterior;
          xls.Cerrar(False);
        end;
      end;
      xls.Free;
      xls := NIL;
      Screen.Cursor := cursorAnterior;
    end;
  end;
end;


end.
