// centralizamos el registro de clases
unit uInicioYFinal;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
  uCosa,
  uCosaConNombre,
  uActores,
  uforzamientos,
  uActorNodal,
  uGlobs,
  uFuncionesReales,
  uSalasDeJuego,
{$IFDEF MONITORES}
  uEventosOptSim,
  uManejadoresDeMonitores,
  uReferenciaMonitor,
  uReferenciaMonitorConsola,
  uReferenciaMonArchivo,
  uReferenciaMonHistograma,
  uReferenciaMonSimRes,
{$IFDEF MODOGRAFICO}
  uReferenciaMonitorGraficoSimple,
{$ENDIF}
{$ENDIF}
{$IFDEF INFOTIPOS}
  uInfoCosa,
{$ENDIF}
  uGeneradores,
  uGTer_Basico,
  ugter_basico_trep,
  ugter_basico_PyCVariable,
{$IFDEF MIPSimplex}
  uGTer_OnOffPorPoste,
  {$IFDEF COMBUSTIBLES}
  uGTer_OnOffPorPosteV2,
  ugter_onoffporpasoV2,
  ugter_arranqueparadaV2,
  ugter_combinadoV2,
  {$ENDIF}
  ugter_combinado,
  uGTer_OnOffPorPaso,
  ugter_onoffporpaso_conrestricciones,
  uGTer_ArranqueParada,
  usolartermico,
  usolarPV,
{$ENDIF}
  ubiomasaembalsable,
  uParqueEolico,
  uParqueEolico_vxy,
  uDemandas01, uDemandaDetallada, uDemandaAnioBaseEIndices,
  uDemandaCombustible, uDemandaCombustibleAnioBaseEIndices,
  uArcos, uNodos,
  uHidroConEmbalse,
  uHidroConEmbalseBinacional,
  uHidroDePasada,
  uHidroConBombeo,
  uMercadoSpot,
  uMercadoSpot_postizado,
  uMercadoSpotConDetalleHorarioSemanal,
  ucontratomodalidaddevolucion,
  ubancodebaterias01,
  uarcoconsalidaprogramable,
  uUsoGestionable_postizado,
  uFuenteWeibull,
  uFuenteGaussiana,
  uFuenteConstante,
  uFuenteUniforme,
  uFuenteSintetizador, uFuenteCombinacion, uFuenteProducto, uFuenteSelector,
  ufuentetiempo,
  ufuentesinusoide,
  ufuentemaxmin,
  uCombustible,
  ufichasLPD,
  upronostico,
  ufichasdeterminismos_obsoleta, // obsoleta, solo para leer salas viejas
  uEstados,
  uSuministroCombustible,
  uGNLSumIntermedio,
  uGNLSuministroMultiCliente,
  uGNLSuministroCombustibleSimple,
  uGNLSumConector,
  uGNLSumComb_TakeOrPay_Spot,
  uGNLProveedor,
  uGNLPlanta,
  uGNLListaContratoSuministro,
  uGNLGasoducto,
  uGNLContratoSuministro,
  uSuministroCombustible_TakeOrPay,
  ugter_ConectableASuministro,
  ulistaplantillassr3,
  ufuenteselector_horario,
  unodocombustible,
  uTSumComb,
  ugsimple_bicombustible,
 uActorNodalCombustible,
  uarcocombustible,
  uTSumComConAlmacenYAgenda,
  uescenarios;

procedure AlInicio;
procedure AlFinal;

implementation

var
  cnt_llamadas: integer;


procedure AlInicio;
begin
  Inc(cnt_llamadas);
  if (cnt_llamadas > 1) then
    exit;

  uCosa.AlInicio; // tiene que ser la primera
  uCosaConNombre.AlInicio; //tiene que ser la segunda
  uGlobs.AlInicio;
  uFuncionesReales.AlInicio;
  uSalasDeJuego.AlInicio;
{$IFDEF INFOTIPOS}
  uInfoCosa.AlInicio;
{$ENDIF}
{$IFDEF MONITORES}
  uEventosOptSim.alInicio;
  uManejadoresDeMonitores.AlInicio;
  uReferenciaMonitor.AlInicio;
  uReferenciaMonitorConsola.AlInicio;
  uReferenciaMonArchivo.AlInicio;
  uReferenciaMonHistograma.AlInicio;
  uReferenciaMonSimRes.AlInicio;
{$IFDEF MODOGRAFICO}
  uReferenciaMonitorGraficoSimple.AlInicio;
{$ENDIF}
{$ENDIF}
  uforzamientos.AlInicio;

// Actors ============================
  uActores.AlInicio;
  uActorNodal.AlInicio;
  uActorNodalCombustible.AlInicio;
  uNodos.AlInicio;
  uArcos.AlInicio;
  uArcoCombustible.AlInicio;
  uArcoConSalidaProgramable.AlInicio;
  uDemandas01.AlInicio;
  uDemandaDetallada.AlInicio;
  uDemandaAnioBaseEIndices.AlInicio;
  uGeneradores.AlInicio;
  uGTer_Basico.AlInicio;
  ugter_basico_trep.AlInicio;
  ugter_basico_PyCVariable.AlInicio;
  {$IFDEF MIPSimplex}
  uGTer_OnOffPorPoste.AlInicio;
  {$IFDEF COMBUSTIBLES}
  uGTer_OnOffPorPosteV2.AlInicio;
  ugter_onoffporpasoV2.AlInicio;
  ugter_arranqueparadaV2.AlInicio;
  ugter_combinadoV2.AlInicio;
  {$ENDIF}
  ucombustible.AlInicio;
  unodocombustible.AlInicio;
  uDemandaCombustibleAnioBaseEIndices.AlInicio;
  uTSumComConAlmacenYAgenda.AlInicio;
  ugter_combinado.AlInicio;
  uGTer_OnOffPorPaso.AlInicio;
  ugter_onoffporpaso_conrestricciones.AlInicio;
  uGTer_ArranqueParada.AlInicio;
  usolartermico.AlInicio;
  usolarPV.AlInicio;
{$ENDIF}
  ubiomasaembalsable.AlInicio;
  uParqueEolico.AlInicio;
  uParqueEolico_vxy.AlInicio;
  uHidroConEmbalse.AlInicio;
  uHidroConBombeo.AlInicio;
  uHidroConEmbalseBinacional.AlInicio;
  uHidroDePasada.AlInicio;
  uMercadoSpot.AlInicio;
  uMercadoSpot_postizado.AlInicio;
  uMercadoSpotConDetalleHorarioSemanal.AlInicio;
  ucontratomodalidaddevolucion.AlInicio;
  ubancodebaterias01.AlInicio;
  uUsoGestionable_postizado.AlInicio;

  uSuministroCombustible.AlInicio;
  uGNLSumIntermedio.AlInicio;
  uGNLSuministroMultiCLiente.AlInicio;
  uGNLSuministroCombustibleSimple.AlInicio;
  uGNLSumConector.AlInicio;
  uGNLSUmCOmb_TakeOrPay_Spot.AlInicio;
  UGNLProveedor.AlInicio;
  uGNLPlanta.AlInicio;
  uGNLListaContratoSuministro.AlInicio;
  uGNLGasoducto.AlInicio;
  uGNLContratoSuministro.AlInicio;
  uSuministroCombustible_TakeOrPay.AlInicio;
  ugter_ConectableASuministro.AlInicio;


// Fuentes =============================================
  uFuenteWeibull.AlInicio;
  uFuenteGaussiana.AlInicio;
  uFuenteConstante.AlInicio;
  uFuenteUniforme.AlInicio;
  uFuenteSintetizador.AlInicio;
  uFuenteCombinacion.AlInicio;
  uFuenteProducto.AlInicio;
  uFuenteSelector.AlInicio;
  ufuentetiempo.AlInicio;
  ufuentesinusoide.AlInicio;
  ufuentemaxmin.AlInicio;
  uFuenteSintetizador.AlInicio;
  ufuenteselector_horario.AlInicio;


  uFichasLPD.AlInicio;
  uEstados.AlInicio;
  upronostico.AlInicio;
  ufichasdeterminismos_obsoleta.AlInicio;
  ulistaplantillassr3.AlInicio;
  uescenarios.AlInicio;

end;

procedure AlFinal;
begin
  Dec(cnt_llamadas);
  if (cnt_llamadas > 0) then
    exit;

  uGlobs.AlFinal;
  uFuncionesReales.AlFinal;
  uSalasDeJuego.AlFinal;
{$IFDEF MONITORES}
  uEventosOptSim.alFinal;
  uManejadoresDeMonitores.AlFinal;
  uReferenciaMonitor.AlFinal;
  uReferenciaMonitorConsola.AlFinal;
  uReferenciaMonArchivo.AlFinal;
  uReferenciaMonHistograma.AlFinal;
  uReferenciaMonSimRes.AlFinal;
  {$IFDEF MODOGRAFICO}
  uReferenciaMonitorGraficoSimple.AlFinal;
  {$ENDIF}
{$ENDIF}
{$IFDEF INFOTIPOS}
  uInfoCosa.AlFinal;
{$ENDIF}
  uActores.AlFinal;
  uForzamientos.AlFinal;
  uActorNodal.AlFinal;
  uActorNodalCombustible.AlFinal;
  uNodos.AlFinal;
  uArcos.AlFinal;
  uArcoCombustible.AlFinal;
  uArcoConSalidaProgramable.AlFinal;
  uDemandas01.AlFinal;
  uDemandaDetallada.AlFinal;
  uDemandaAnioBaseEIndices.AlFinal;
  uDemandaCombustibleAnioBaseEIndices.AlFinal;
  uTSumComConAlmacenYAgenda.AlFinal;
  uGeneradores.AlFinal;
  uGTer_Basico.AlFinal;
  ugter_basico_trep.AlFinal;
  ugter_basico_PyCVariable.AlFinal;
{$IFDEF MIPSimplex}
  uGTer_OnOffPorPoste.AlFinal;
  {$IFDEF COMBUSTIBLES}
  uGTer_OnOffPorPosteV2.AlFinal;
  ugter_onoffporpasoV2.AlFinal;
  ugter_arranqueparadaV2.AlFinal;
  ugter_combinadoV2.AlFinal;
  {$ENDIF}
  ucombustible.AlFinal;
  unodocombustible.AlFinal;

  ugter_combinado.AlFinal;
  uGTer_OnOffPorPaso.AlFinal;
  ugter_onoffporpaso_conrestricciones.AlFinal;
  uGTer_ArranqueParada.AlFinal;
  usolartermico.AlFinal;
  usolarPV.AlFinal;
{$ENDIF}
  ubiomasaembalsable.AlFinal;
  uParqueEolico_vxy.AlFinal;
  uHidroConEmbalse.AlFinal;
  uHidroConBombeo.AlFinal;
  uHidroConEmbalseBinacional.AlFinal;
  uHidroDePasada.AlFinal;
  uMercadoSpot.AlFinal;
  uMercadoSpot_postizado.AlFinal;
  uMercadoSpotConDetalleHorarioSemanal.AlFinal;
  ucontratomodalidaddevolucion.AlFinal;
  ubancodebaterias01.AlFinal;

  uUsoGestionable_postizado.AlFinal;
  uCosaConNombre.AlFinal;
  uCosa.AlFinal;

  uFuenteWeibull.AlFinal;
  uFuenteGaussiana.AlFinal;
  uFuenteConstante.AlFinal;
  uFuenteUniforme.AlFinal;

  uFuenteSintetizador.AlFinal;
  uFuenteCombinacion.AlFinal;
  uFuenteProducto.AlFinal;
  uFuenteSelector.AlFinal;
  ufuentetiempo.AlFinal;
  ufuentesinusoide.AlFinal;
  ufuentemaxmin.AlFinal;

  uFichasLPD.AlFinal;
  uEstados.AlFinal;

  upronostico.AlFinal;
  uFuenteSintetizador.AlFinal;
  ufichasdeterminismos_obsoleta.AlFinal;

  uSuministroCombustible.AlFinal;
  uGNLSumIntermedio.AlFinal;
  uGNLSuministroMultiCLiente.AlFinal;
  uGNLSuministroCombustibleSimple.AlFinal;
  uGNLSumConector.AlFinal;
  uGNLSUmCOmb_TakeOrPay_Spot.AlFinal;
  UGNLProveedor.AlFinal;
  uGNLPlanta.AlFinal;
  uGNLListaContratoSuministro.AlFinal;
  uGNLGasoducto.AlFinal;
  uGNLContratoSuministro.AlFinal;
  uSuministroCombustible_TakeOrPay.AlFinal;
  ugter_ConectableASuministro.AlFinal;
  ulistaplantillassr3.AlFinal;
  ufuenteselector_horario.AlFinal;
  uescenarios.AlFinal;
end;

begin
  cnt_llamadas := 0;
end.
